/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ethernet.c,v 1.2.1.1 2004/10/13 05:57:02 abe Exp abe $
 */

/* 
 *  Ethernet 
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/ethernet.h>
#include <net/if_llc.h>
#include <net/if_arp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/if_ether.h>
#include <netinet6/if6_ether.h>
#include <netinet6/nd6.h>

#include <net/if_var.h>
#include <net/if6_var.h>


/*
 *  ѿ
 */

UB ether_broad_cast_addr[ETHER_ADDR_LEN] = {
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff
	};

/*
 *  ѿ
 */

/* ͥåȥ󥿥ե¤ */

#ifdef SUPPORT_INET4

static T_IFNET ether_ifnet = {
	NULL,			/* ͥåȥ󥿥եΥեȥ	*/
	{
		IPV4_ADDR_LOCAL,	/* IPv4 ɥ쥹			*/
		IPV4_ADDR_LOCAL_MASK,	/* ֥ͥåȥޥ			*/
		},
	};

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

static T_IFNET ether_ifnet = {
	NULL,			/* ͥåȥ󥿥եΥեȥ	*/
	{},			/* IPv6 ɥ쥹				*/
	{},			/* ޥ㥹 IPv6 ɥ쥹			*/
	};

#endif	/* of #ifdef SUPPORT_INET6 */

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

T_IF_STATS if_stats;

#endif	/* of #ifdef SUPPORT_MIB */

#ifdef ETHER_CFG_802_WARNING

/*
 *  ؿ
 */

static void ieee_802_input (T_NET_BUF *input);

/*
 *  ieee_802_input -- IEEE 802.3 Ͻ
 */

static void
ieee_802_input (T_NET_BUF *input)
{
	static UB mac_addr[sizeof("00:00:00:00:00:00")];

	T_8023MAC_HDR	*mhdr;
	T_8022SNAP_HDR	*shdr;

	mhdr = GET_8023MAC_HDR(input);
	shdr = GET_8022SNAP_HDR(input);
	syslog(LOG_WARNING, "[ETHER] unexp 802.3 from: %s, proto: %04x.",
	                    mac2str(mac_addr, mhdr->shost), ntohs(*(UH*)&shdr->type));
	}

#endif	/* of #ifdef ETHER_CFG_802_WARNING */

/*
 *  ether_get_ifnet -- ͥåȥ󥿥ե¤Τ֤
 */

T_IFNET *
ether_get_ifnet (void)
{
	return &ether_ifnet;
	}

#ifdef SUPPORT_INET6

/*
 *  ether_in6_resolve_multicast -- ͥåȤΥޥ㥹ȥɥ쥹ؤѴ
 */

ER
ether_in6_resolve_multicast (T_ETHER_ADDR *ifaddr, T_IN6_ADDR *maddr)
{
	/* ޥ㥹ȥɥ쥹å롣*/
	if (!IN6_IS_ADDR_MULTICAST(maddr))
		return E_PAR;

	/* ͥåȤΥޥ㥹ȥɥ쥹ؤѴ */
	ether_map_ipv6_multicast(ifaddr, maddr);

	return E_OK;
	}

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  ether_raw_output -- Ethernet 󥿥եνϴؿMAC ɥ쥹̵
 */

ER
ether_raw_output (T_NET_BUF *output, TMO tmout)
{
	ER error = E_OK;

	/* Ethernet ϥ塼롣*/
	if ((error = tsnd_dtq(DTQ_ETHER_OUTPUT, (VP_INT)output, tmout)) != E_OK) {
		syscall(rel_net_buf(output));
		IF_ETHER_NIC_RESET(IF_ETHER_NIC_GET_SOFTC());
		NET_COUNT_ETHER(net_count_ether.out_err_packets, 1);
		NET_COUNT_MIB(if_stats.ifOutDiscards, 1);
		}
	return error;
	}

/*
 *  ether_output -- Ethernet 󥿥եνϴؿMAC ɥ쥹ͭ
 */

ER
ether_output (T_NET_BUF *output, VP dst, T_IF_ADDR *gw, TMO tmout)
{
	T_IF_SOFTC	*ic;
	ER		error = E_OK;

	/*  MAC ɥ쥹ꤹ롣*/
	ic = IF_ETHER_NIC_GET_SOFTC();
	memcpy(GET_ETHER_HDR(output)->shost, ic->ifaddr.lladdr, ETHER_ADDR_LEN);

	switch(ntohs(GET_ETHER_HDR(output)->type)) {

#ifdef SUPPORT_INET4

	case ETHER_TYPE_IP:		/* IPv4	*/
		if (arp_resolve(&ic->ifaddr, output, *(UW*)dst)) {	/* TRUE ʤ饢ɥ쥹 */
			error = ether_raw_output(output, tmout);
			}
		break;

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

	case ETHER_TYPE_IPV6:		/* IPv6	*/
		error = nd6_storelladdr((T_ETHER_ADDR*)GET_ETHER_HDR(output)->dhost,
		                        (T_IN6_ADDR*)dst, gw);
		if (error == E_OK)
			error = ether_raw_output(output, tmout);
		else
			syscall(rel_net_buf(output));
		break;

#endif	/* of #ifdef SUPPORT_INET6 */

	default:
		syscall(rel_net_buf(output));
		error = E_PAR;
		NET_COUNT_MIB(if_stats.ifOutErrors, 1);
		break;
		}

	if (error != E_OK)
		NET_COUNT_ETHER(net_count_ether.out_err_packets, 1);
	return error;
	}

/*
 *  Ethernet ϥ
 */

void
ether_output_task(VP_INT exinf)
{
	T_IF_SOFTC	*ic;
	T_NET_BUF	*output;
	ID		tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[ETHER OUTPUT:%d] started.", tskid);

	ic = IF_ETHER_NIC_GET_SOFTC();

	while (TRUE) {
		while (rcv_dtq(DTQ_ETHER_OUTPUT, (VP_INT*)(VP)&output) == E_OK) {
			NET_COUNT_ETHER(net_count_ether.out_octets,  output->len);
			NET_COUNT_MIB(if_stats.ifOutOctets, output->len + 8);
			NET_COUNT_ETHER(net_count_ether.out_packets, 1);

#ifdef SUPPORT_MIB
			if ((*(GET_ETHER_HDR(output)->dhost) & ETHER_MCAST_ADDR) == 0) {
				NET_COUNT_MIB(if_stats.ifOutUcastPkts, 1);
				}
			else {
				NET_COUNT_MIB(if_stats.ifOutNUcastPkts, 1);
				}
#endif	/* of #ifdef SUPPORT_MIB */

			syscall(wai_sem(ic->semid_txb_ready));

			IF_ETHER_NIC_START(ic, output);

#ifndef ETHER_NIC_CFG_RELEASE_NET_BUF

			syscall(rel_net_buf(output));

#endif	/* of #ifndef ETHER_NIC_CFG_RELEASE_NET_BUF */
			}
		}
	}

/*
 *  Ethernet ϥ
 */

void
ether_input_task(VP_INT exinf)
{
#if defined(SUPPORT_INET4) && defined(ETHER_CFG_ACCEPT_ALL) && defined(ETHER_CFG_MCAST_WARNING)

	static UB dhost_addr[sizeof("00:00:00:00:00:00")];

#endif	/* of #if defined(SUPPORT_INET4) && defined(ETHER_CFG_ACCEPT_ALL) && defined(ETHER_CFG_MCAST_WARNING) */

	static UB shost_addr[sizeof("00:00:00:00:00:00")];

	T_IF_SOFTC	*ic;
	T_NET_BUF	*input;
	T_ETHER_HDR	*eth;
	ID		tskid;
	UH		proto;

	/* ͥåȥ󥿥ե롣*/
	ifinit();

	/* NIC 롣*/
	ic = IF_ETHER_NIC_GET_SOFTC();
	IF_ETHER_NIC_PROBE(ic);
	IF_ETHER_NIC_INIT(ic);

	/* Ethernet ϥư */
	syscall(act_tsk(ETHER_OUTPUT_TASK));

	/* ͥåȥޥư */
	syscall(act_tsk(NET_TIMER_TASK));

	get_tid(&tskid);
	mac2str(shost_addr, ic->ifaddr.lladdr);

	syslog(LOG_NOTICE, "[ETHER INPUT:%2d] started on MAC Addr: %s.",
	       tskid, shost_addr);

#ifdef SUPPORT_INET4

	/* ARP 롣*/
	arp_init();

#endif	/* of #ifdef SUPPORT_INET4 */

	ether_ifnet.ic = ic;

	while (TRUE) {
		syscall(wai_sem(ic->semid_rxb_ready));
		if ((input = IF_ETHER_NIC_READ(ic)) != NULL) {
			NET_COUNT_ETHER(net_count_ether.in_octets,  input->len);
			NET_COUNT_MIB(if_stats.ifInOctets, input->len + 8);
			NET_COUNT_ETHER(net_count_ether.in_packets, 1);
			eth = GET_ETHER_HDR(input);
			proto = ntohs(eth->type);

#ifdef SUPPORT_MIB
			if ((*eth->dhost & ETHER_MCAST_ADDR) == 0) {
				NET_COUNT_MIB(if_stats.ifInUcastPkts, 1);
				}
			else {
				NET_COUNT_MIB(if_stats.ifInNUcastPkts, 1);
				}
#endif	/* of #ifdef SUPPORT_MIB */

#if defined(SUPPORT_INET4) && defined(ETHER_CFG_ACCEPT_ALL)

			if ((*eth->dhost & ETHER_MCAST_ADDR) && *eth->dhost != 0xff) {

#ifdef ETHER_CFG_MCAST_WARNING

				if (proto <= 1500)
					proto = ntohs(*(UH*)&(GET_8022SNAP_HDR(input)->type));
				syslog(LOG_WARNING, "[ETHER] mcast addr  from: %s, to: %s, proto: %04x.",
				                    mac2str(shost_addr, eth->shost),
				                    mac2str(dhost_addr, eth->dhost),
				                    proto);

#endif	/* of #ifdef ETHER_CFG_MCAST_WARNING */

				NET_COUNT_ETHER(net_count_ether.in_err_packets, 1);
				NET_COUNT_MIB(if_stats.ifInErrors, 1);
				syscall(rel_net_buf(input));
				continue;
				}

#endif	/* of #if defined(SUPPORT_INET4) && defined(ETHER_CFG_ACCEPT_ALL) */

			switch(proto) {

#ifdef SUPPORT_INET4

			case ETHER_TYPE_IP:		/* IP	*/
				ip_input(input);
				break;

			case ETHER_TYPE_ARP:		/* ARP	*/
				arp_input(&ic->ifaddr, input);
				break;

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

			case ETHER_TYPE_IPV6:		/* IPv6	*/
				ip6_input(input);
				break;

#endif	/* of #ifdef SUPPORT_INET6 */

			default:

#ifdef ETHER_CFG_UNEXP_WARNING

#ifdef ETHER_CFG_802_WARNING

				if (proto <= 1500)
					ieee_802_input(input);
				else
					syslog(LOG_NOTICE, "[ETHER] unexp proto from: %s, proto: %04x.",
					                   mac2str(shost_addr, GET_ETHER_HDR(input)->shost), proto);

#else	/* of #ifdef ETHER_CFG_802_WARNING */

				syslog(LOG_INFO, "[ETHER] unexp proto from: %s, proto: %04x.",
				                   mac2str(shost_addr, GET_ETHER_HDR(input)->shost), proto);

#endif	/* of #ifdef ETHER_CFG_802_WARNING */

#endif	/* of #ifdef ETHER_CFG_UNEXP_WARNING */

				NET_COUNT_ETHER(net_count_ether.in_err_packets, 1);
				NET_COUNT_MIB(if_stats.ifUnknownProtos, 1);
				syscall(rel_net_buf(input));
				break;
				}
			}
		}
	}
