/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_discard_srv.c,v 1.2.1.1 2004/10/13 05:59:09 abe Exp abe $
 */

/* 
 *  DISCARD 
 *
 *    ʥԡ API
 *    IPv4
 *    IPv6
 */

#include <t_services.h>
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>

/*
 *  ɽ
 */

/*#define SHOW_RCV_RANGE*/

/*
 *  TCP DISCARD Х
 */

#define BUF_SIZE		2048

#ifdef USE_COPYSAVE_API

void
tcp_discard_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	T_IPEP	dst;
	UB	*buf;
	ER_UINT	rlen;
	ER	error;
	int	count, total;
	ID	tskid;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP DISCARD SRV (CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = TCP_ACP_CEP((ID)exinf, TCP_DISCARD_SRV_REPID, &dst, TMO_FEVR)) == E_OK) {
			count = total = 0;
			IP2STR(addr, &dst.ipaddr);
			get_tim(&time);
			syslog(LOG_NOTICE, "[TDS:%02d RCV] connected:  %6d, from: %s.%d",
			                   (ID)exinf, time / SYSTIM_HZ, addr, dst.portno);
			while ((rlen = tcp_rcv_buf((ID)exinf, (VP*)(VP)&buf, TMO_FEVR)) > 0) {
				count ++;

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TDS:%02d RCV] count: %4d, len: %4d, data: %02x -> %02x",
				       (ID)exinf, count, rlen, *buf, *(buf + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */

				if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK) {
					syslog(LOG_WARNING, "[TDS:%02d RCV] rel buf error: %s",
					                    (ID)exinf, itron_strerror(error));
					rlen = 0;
					break;
					}
				total += rlen;
				}

			if (rlen != 0)
				syslog(LOG_WARNING, "[TDS:%02d RCV] recv buf error: %s", (ID)exinf, itron_strerror(rlen));

			if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
				syslog(LOG_WARNING, "[TDS:%02d RCV] shutdown error: %s", (ID)exinf, itron_strerror(error));

			if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
				syslog(LOG_WARNING, "[TDS:%02d RCV] close error: %s", (ID)exinf, itron_strerror(error));

			get_tim(&time);
			syslog(LOG_NOTICE, "[TDS:%02d RCV] finished:   %6d,            rcv: %4d, len: %d",
			                   (ID)exinf, time / SYSTIM_HZ, count, total);
			}
		else
			syslog(LOG_WARNING, "[TDS:%02d RCV] accept error: %s", (ID)exinf, itron_strerror(error));
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_discard_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	static UB buffer[BUF_SIZE];

	T_IPEP	dst;
	UB	*buf = buffer;
	ER_UINT	rlen;
	ER	error;
	int	count, total;
	ID	tskid;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP DISCARD SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = TCP_ACP_CEP((ID)exinf, TCP_DISCARD_SRV_REPID, &dst, TMO_FEVR)) == E_OK) {
			count = total = 0;
			IP2STR(addr, &dst.ipaddr);
			get_tim(&time);
			syslog(LOG_NOTICE, "[TDS:%02d RCV] connected:  %6d, from: %s.%d",
			                   (ID)exinf, time / SYSTIM_HZ, addr, dst.portno);
			while ((rlen = tcp_rcv_dat((ID)exinf, buf, BUF_SIZE - 1, TMO_FEVR)) > 0) {
				count ++;

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TDS:%02d RCV] count: %4d, len: %4d, data: %02x -> %02x",
				       (ID)exinf, count, rlen, *buf, *(buf + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */

				total += rlen;
				}
			if (rlen != 0)
				syslog(LOG_WARNING, "[TDS:%02d RCV] recv error: %s", (ID)exinf, itron_strerror(rlen));

			if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
				syslog(LOG_WARNING, "[TDS:%02d RCV] shutdown error: %s", (ID)exinf, itron_strerror(error));

			if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
				syslog(LOG_WARNING, "[TDS:%02d RCV] close error: %s", (ID)exinf, itron_strerror(error));

			get_tim(&time);
			syslog(LOG_NOTICE, "[TDS:%02d RCV] finished:   %6d,            rcv: %4d, len: %d",
			                   (ID)exinf, time / SYSTIM_HZ, count, total);
			}
		else
			syslog(LOG_WARNING, "[TDS:%02d RCV] accept error: %s", (ID)exinf, itron_strerror(error));
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */
