/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/* 
 *  TCP ECHO  #1
 *
 *    Ʊ췿
 *    Υ֥å󥰥
 *    ʥԡ API
 *    IPv4/IPv6
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>

/*
 *  ɽ
 */

/*#define SHOW_RCV_RANGE*/

/*
 *  ͥˡλ
 */

/*#define USE_TCP_SHT_CEP*/

/*
 *  ѿ
 */

/*
 *  :
 *
 *    BUF_SIZE  TCP 
 *    ɥХåե + ɥХåե 
 *    3/2 ܤ礭ʤСǥåɥåǽ롣
 */

#define BUF_SIZE	(((1024*2)+(1024*2))*3/2)

static T_IPEP		dst;			/* ³		*/

#ifdef USE_TCP_NON_BLOCKING

static UB 		buffer[BUF_SIZE];
static ER		nblk_error = E_OK;
static int		nblk_slen  = 0;
static int		nblk_rlen  = 0;

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

#ifdef USE_COPYSAVE_API

#else	/* of #ifdef USE_COPYSAVE_API */

static UB 		buffer[BUF_SIZE];

#endif	/* of #ifdef USE_COPYSAVE_API */

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

#ifdef USE_TCP_NON_BLOCKING

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	ER	error = E_OK;

	switch (fncd) {

	case TFN_TCP_ACP_CEP:
		nblk_error = (ER)p_parblk;
		IP2STR(addr, &dst.ipaddr);
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_RCV_DAT:
		if ((nblk_rlen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TES:%02d CBN] recv error: %s", cepid, itron_strerror(nblk_rlen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_SND_DAT:
		if ((nblk_slen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TES:%02d CBN] send error: %s", cepid, itron_strerror(nblk_slen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_CLS_CEP:
		if ((nblk_error = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TES:%02d CBN] close error: %s", cepid, itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_RCV_BUF:
		if ((nblk_rlen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TES:%02d CBN] rbuf error: %s", cepid, itron_strerror(nblk_rlen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_GET_BUF:
		if ((nblk_slen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TES:%02d CBN] sbuf error: %s", cepid, itron_strerror(nblk_slen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_CON_CEP:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		break;
		}
	return error;
	}

#ifdef USE_COPYSAVE_API

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	int	rblen, sblen, rlen, slen;
	int	soff, scount, rcount, total;
	UB	*rbuf, *sbuf, head, tail;
	ID	tskid;
	ER	error = E_OK;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK,CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = TCP_ACP_CEP((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", (ID)exinf, itron_strerror(error));
			continue;
			}

		/* ꤫³ޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		if (nblk_error == E_OK) {
			IP2STR(addr, &dst.ipaddr);
			get_tim(&now);
			syslog(LOG_NOTICE, "[TES:%02d ACP] connected:  %6d, from: %s.%d",
			                   (ID)exinf, now / SYSTIM_HZ, addr, dst.portno);
			}
		else {
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", (ID)exinf, itron_strerror(nblk_error));
			continue;
			}

		rlen = scount = rcount = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_buf((ID)exinf, (VP *)&rbuf, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s", (ID)exinf, itron_strerror(error));
				break;
				}

			/* ޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

			rblen = nblk_rlen;

			if (rblen < 0) {	/* 顼 */
				syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s", 
				                   (ID)exinf, itron_strerror(rblen));
				break;
				}
			else if (rblen == 0)	/* λ */
				break;

			/* ХåեλĤˤꡢĹĴ롣*/
			if (rblen > BUF_SIZE - rlen)
				rblen = BUF_SIZE - rlen;
			total += rblen;
			rlen   = rblen;

			head = *rbuf;
			tail = *(rbuf + rblen - 1);
			rcount ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TES:%02d RCV] "
			                   "rcount: %4d, len: %4d, data %02x -> %02x",
			                   (ID)exinf, rcount, rblen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			memcpy(buffer, rbuf, rblen);

			if ((error = tcp_rel_buf((ID)exinf, rlen)) < 0) {
				syslog(LOG_NOTICE, "[TES:%02d REL] error: %s",
				                   (ID)exinf, itron_strerror(error));
				break;
				}

			soff = 0;
			while (rlen > 0) {

				if ((error = tcp_get_buf((ID)exinf, (VP *)&sbuf, TMO_NBLK)) != E_WBLK) {
					syslog(LOG_NOTICE, "[TES:%02d GET] error: %s",
					                   (ID)exinf, itron_strerror(error));
					goto err_fin;
					}

				/* ХåեγλޤԤġ*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

				if ((sblen = nblk_slen) < 0) {
					syslog(LOG_NOTICE, "[TES:%02d GET] error: %s",
					                   (ID)exinf, itron_strerror(sblen));
					goto err_fin;
					}

				scount ++;
				slen = sblen < rlen ? sblen : rlen;
				memcpy(sbuf, buffer + soff, slen);

				if ((error = tcp_snd_buf((ID)exinf, slen)) != E_OK) {
					syslog(LOG_NOTICE, "[TES:%02d SND] error: %s",
					                   (ID)exinf, itron_strerror(error));
					goto err_fin;
					}
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TES:%02d SND] scount: %4d, len: %4d",
				                   (ID)exinf, scount, slen);
#endif	/* of #ifdef SHOW_RCV_RANGE */

				rlen -= slen;
				soff += slen;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d SHT] error: %s", (ID)exinf, itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TES:%02d CLS] error: %s", (ID)exinf, itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d FIN] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, now / SYSTIM_HZ, scount, rcount, total);
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	int	rlen, slen;
	int	soff, scount, rcount, total;
	ID	tskid;
	ER	error;
	UB	head, tail;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = TCP_ACP_CEP((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", (ID)exinf, itron_strerror(error));
			continue;
			}

		/* ꤫³ޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		if (nblk_error == E_OK) {
			IP2STR(addr, &dst.ipaddr);
			get_tim(&now);
			syslog(LOG_NOTICE, "[TES:%02d ACP] connected:  %6d, from: %s.%d",
			                   (ID)exinf, now / SYSTIM_HZ, addr, dst.portno);
			}
		else {
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", (ID)exinf, itron_strerror(nblk_error));
			continue;
			}

		scount = rcount = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_dat((ID)exinf, buffer, BUF_SIZE - 1, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s",
				                   (ID)exinf, itron_strerror(error));
				break;
				}

			/* λޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

			rlen = nblk_rlen;
			if (rlen < 0) {
				syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s",
				                   (ID)exinf, itron_strerror(rlen));
				break;
				}
			else if (rlen == 0)
				break;

			head = *buffer;
			tail = *(buffer + rlen - 1);
			rcount ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TES:%02d RCV] rcount: %4d, len: %4d, data %02x -> %02x",
			                   (ID)exinf, rcount, rlen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			total += rlen;
			soff = 0;
			while (rlen > 0) {
				scount ++;
				if ((error = tcp_snd_dat((ID)exinf, &buffer[soff], rlen, TMO_NBLK)) != E_WBLK) {
					syslog(LOG_NOTICE, "[TES:%02d SND] error: %s",
					                   (ID)exinf, itron_strerror(error));
					goto err_fin;
					}

				/* λޤԤġ*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TES:%02d SND] scount: %4d, len: %4d",
				                   (ID)exinf, scount, slen);
#endif	/* of #ifdef SHOW_RCV_RANGE */

				slen = nblk_slen;
				if (slen < 0) {
					syslog(LOG_NOTICE, "[TES:%02d SND] error: %s",
					                   (ID)exinf, itron_strerror(slen));
					goto err_fin;
					}
				rlen -= slen;
				soff += slen;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d SHT] error: %s", (ID)exinf, itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TES:%02d CLS] error: %s", (ID)exinf, itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d FIN] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, now / SYSTIM_HZ, scount, rcount, total);
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

#ifdef USE_COPYSAVE_API

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	int	rblen, sblen, rlen, slen;
	int	soff, scount, rcount, total;
	UB	*rbuf, *sbuf, head, tail;
	ID	tskid;
	ER	error = E_OK;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (TCP_ACP_CEP((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_FEVR) != E_OK) {
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", (ID)exinf, itron_strerror(error));
			continue;
			}

		scount = rcount = total = 0;
		IP2STR(addr, &dst.ipaddr);
		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d ACP] connected:  %6d, from: %s.%d", (ID)exinf, now / SYSTIM_HZ, addr, dst.portno);
		while (TRUE) {
			if ((rblen = tcp_rcv_buf((ID)exinf, (VP *)&rbuf, TMO_FEVR)) <= 0) {
				if (rblen != E_OK)
					syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s",
					                   (ID)exinf, itron_strerror(rblen));
				break;
				}

			head = *rbuf;
			tail = *(rbuf + rblen - 1);
			rcount ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TES:%02d RCV] rcount: %4d, len: %4d, data %02x -> %02x",
			       (ID)exinf, rcount, rblen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			rlen   = rblen;
			total += rblen;
			soff = 0;
			while (rlen > 0) {

				if ((sblen = tcp_get_buf((ID)exinf, (VP *)&sbuf, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TES:%02d GET] error: %s",
					                   (ID)exinf, itron_strerror(sblen));
					goto err_fin;
					}

				scount ++;
				slen = rlen < sblen ? rlen : sblen;
				memcpy(sbuf, rbuf + soff, slen);
				if ((error = tcp_snd_buf((ID)exinf, slen)) != E_OK) {
					syslog(LOG_NOTICE, "[TES:%02d SND] error: %s",
					                   (ID)exinf, itron_strerror(error));
					goto err_fin;
					}
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TES:%02d SND] scount: %4d, len: %4d", (ID)exinf, scount, slen);
#endif	/* of #ifdef SHOW_RCV_RANGE */

				rlen -= slen;
				soff += slen;
				}

			if ((error = tcp_rel_buf((ID)exinf, rblen)) < 0) {
				syslog(LOG_NOTICE, "[TES:%02d REL] error: %s", (ID)exinf, itron_strerror(error));
				break;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d SHT] error: %s", (ID)exinf, itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d CLS] error: %s", (ID)exinf, itron_strerror(error));

		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d FIN] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, now / SYSTIM_HZ, scount, rcount, total);
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	int	rlen, slen;
	int	soff, scount, rcount, total;
	ID	tskid;
	ER	error = E_OK;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (TCP_ACP_CEP((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_FEVR) != E_OK) {
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", (ID)exinf, itron_strerror(error));
			continue;
			}

		scount = rcount = total = 0;
		IP2STR(addr, &dst.ipaddr);
		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d ACP] connected:  %6d, from: %s.%d", (ID)exinf, now / SYSTIM_HZ, addr, dst.portno);
		while (TRUE) {
			if ((rlen = tcp_rcv_dat((ID)exinf, buffer, BUF_SIZE - 1, TMO_FEVR)) <= 0) {
				if (rlen != E_OK)
					syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s",
					                   (ID)exinf, itron_strerror(rlen));
				break;
				}

			rcount ++;
#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TES:%02d RCV] rcount: %4d, len: %4d, data %02x -> %02x",
			       (ID)exinf, rcount, rlen, *buffer, *(buffer + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */

			total += rlen;
			soff = 0;
			while (rlen > 0) {
				scount ++;
				if ((slen = tcp_snd_dat((ID)exinf, &buffer[soff], rlen, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TES:%02d SND] error: %s",
					                   (ID)exinf, itron_strerror(slen));
					goto err_fin;
					}
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TES:%02d SND] scount: %4d, len: %4d", (ID)exinf, scount, slen);
#endif	/* of #ifdef SHOW_RCV_RANGE */

				rlen -= slen;
				soff += slen;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d SHT] error: %s", (ID)exinf, itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d CLS] error: %s", (ID)exinf, itron_strerror(error));

		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d FIN] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, now / SYSTIM_HZ, scount, rcount, total);
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */
