/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: if_ed.c,v 1.2.1.1 2004/10/13 06:00:09 abe Exp abe $
 */

/*
 * Copyright (c) 1995, David Greenman
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice unmodified, this list of conditions, and the following
 *    disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD: src/sys/i386/isa/if_ed.c,v 1.148.2.4 1999/09/25 13:08:18 nyan Exp $
 */

/*
 * Device driver for National Semiconductor DS8390/WD83C690 based ethernet
 *   adapters. By David Greenman, 29-April-1993
 *
 * Currently supports the Western Digital/SMC 8003 and 8013 series,
 *   the SMC Elite Ultra (8216), the 3Com 3c503, the NE1000 and NE2000,
 *   and a variety of similar clones.
 *
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/net.h>
#include <net/net_timer.h>
#include <net/net_count.h>
#include <net/net_buf.h>

#include "if_edreg.h"

/*
 *   RAM Υڡ
 */

#define ED_INT_TXBUF_START	(ED_INT_RAM_BASE / ED_PAGE_SIZE)
#define ED_INT_TXBUF_STOP	(ED_INT_RAM_BASE / ED_PAGE_SIZE + IF_ED_TXBUF_PAGE_SIZE)
#define ED_INT_RXBUF_START	ED_INT_TXBUF_STOP
#define ED_INT_RXBUF_STOP	((ED_INT_RAM_BASE + ED_INT_RAM_SIZE) / ED_PAGE_SIZE)

/*
 *  ͥåȥ󥿥ե˰¸륽եȥ 
 */

typedef struct t_ed_softc {
	UW		nic_addr;			/* NIC Υ١ɥ쥹	*/
	UW		asic_addr;			/* ASIC Υ١ɥ쥹*/
	UH		txb_len[NUM_IF_ED_TXBUF];	/* ХåեΥƥåȿ*/
	UB		txb_inuse;			/* Хåե	*/
	UB		txb_insend;			/* Хåե	*/
	UB		txb_write;			/* 񤭹Хåե	*/
	UB		txb_send;			/* Хåե	*/
	UB		rxb_read;			/* ɤ߹ڡ	*/
	} T_ED_SOFTC;

/*
 *  ͥåȥ󥿥եΥեȥ
 */

/* ͥåȥ󥿥ե˰¸륽եȥ */

static T_ED_SOFTC ed_softc = {
	ED_BASE_ADDRESS + ED_NIC_OFFSET,	/* NIC Υ١ɥ쥹		*/
	ED_BASE_ADDRESS + ED_ASIC_OFFSET,	/* ASIC Υ١ɥ쥹		*/
	};

/* ͥåȥ󥿥ե˰¸ʤեȥ */


T_IF_SOFTC if_softc = {
	{},					/* ͥåȥ󥿥եΥɥ쥹	*/
	0,					/* ॢ			*/
	&ed_softc,				/* ǥХ¸Υեȥ	*/
	SEM_IF_ED_SBUF_READY,			/* ޥե			*/
	SEM_IF_ED_RBUF_READY,			/* ޥե			*/

#ifdef SUPPORT_INET6

	IF_MADDR_INIT,				/* ޥ㥹ȥɥ쥹ꥹ	*/

#endif	/* of #ifdef SUPPORT_INET6 */
	};

/*
 *  ɽѿ
 */

static void ed_pio_readmem (T_ED_SOFTC *sc, UW src, UB *dst, UH amount);
static T_NET_BUF *ed_get_frame (T_ED_SOFTC *sc, UW ring, UH len);
static void ed_xmit (T_IF_SOFTC *ic);
static void ed_stop (T_ED_SOFTC *sc);
static void ed_init_sub (T_IF_SOFTC *ic);
static void ed_setrcr (T_IF_SOFTC *ic);

#ifdef SUPPORT_INET6

static UW ds_crc (UB *addr);
static void ds_getmcaf (T_IF_SOFTC *ic, UW *mcaf);

/*
 *  ds_crc -- ͥåȥɥ쥹 CRC ׻롣
 */

#define POLYNOMIAL	0x04c11db6

static UW
ds_crc (UB *addr)
{
	UW	crc = 0xffffffff;
	int	carry, len, bit;
	UB	byte;

	for (len = ETHER_ADDR_LEN; len -- > 0; ) {
		byte = *addr ++;
		for (bit = 8; bit -- > 0; ) {
			carry   = ((crc & 0x80000000) ? 1 : 0) ^ (byte & 0x01);
			crc   <<= 1;
			byte   >>= 1;
			if (carry)
				crc = (crc ^ POLYNOMIAL) | carry;
			}
		}
	return crc;
	}

#undef POLYNOMIAL

/*
 *  ds_getmcaf -- ޥ㥹ȥɥ쥹ΥꥹȤޥ㥹ȥɥ쥹
 *                ե륿׻롣
 */

static void
ds_getmcaf (T_IF_SOFTC *ic, UW *mcaf)
{
	UW	count, index;
	UB	*af = (UB*)mcaf;

	mcaf[0] = mcaf[1] = 0;

	for (count = MAX_IF_MADDR_CNT; count -- > 0; ) {
		index = ds_crc(ic->maddrs[count].lladdr) >> 26;
		af[index >> 3] |= 1 << (index & 7);
		}
	}

/*
 * ed_setrcr -- 쥸 (RCR) ꤹ롣
 */

static void
ed_setrcr (T_IF_SOFTC *ic)
{
	T_ED_SOFTC	*sc = ic->sc;
	int		ix;
	UW		mcaf[2];

	/* 쥸ڡ 1 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	                 ED_CR_RD2 | ED_CR_PAGE1 | ED_CR_STP);

	/* ޥ㥹ȥե륿ꤹ롣*/
	ds_getmcaf(ic, mcaf);

	/* ޥ㥹Ȥμ */
	for (ix = 0; ix < 8; ix ++)
		sil_wrb_mem((VP)(sc->nic_addr + ED_P1_MAR(ix)), ((UB *)mcaf)[ix]);

	/* 쥸ڡ 0 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STP);

	/* ޥ㥹Ȥȥ˥㥹ȥɥ쥹Τ߼褦ꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RCR), ED_RCR_AM);

	/* NIC ư롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);
	}

/*
 * ed_addmulti -- ޥ㥹ȥɥ쥹ɲä롣
 */

ER
ed_addmulti (T_IF_SOFTC *ic)
{
	ed_setrcr(ic);
	return E_OK;
	}

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 * ed_pio_readmem -- ץ I/O Ȥä NIC Υǡɤ߹
 */

static void
ed_pio_readmem (T_ED_SOFTC *sc, UW src, UB *dst, UH amount)
{
	/* 쥸ڡ 0 򤷡DMA ߤ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);

	/* DMA žꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RBCR0), amount);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RBCR1), amount >> 8);

	/* NIC žɥ쥹ꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RSAR0), src);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RSAR1), src >> 8);

	/* DMA ɤ߹ߤ򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD0 | ED_CR_PAGE0 | ED_CR_STA);

	/* NIC ꤫ɤ߹ */
	while (amount -- > 0)
		*dst ++ = sil_reb_mem((VP)(sc->asic_addr + ED_DATA_OFFSET));
	}

/*
 * ed_pio_writemem -- ץ I/O Ȥä NIC ˥ǡ񤭹
 */

static void
ed_pio_writemem (T_ED_SOFTC *sc, UB *src, UW dst, UH amount)
{
	/* 쥸ڡ 0 򤷡DMA ߤ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);

	/* DMA žꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RBCR0), amount);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RBCR1), amount >> 8);

	/* NIC ž襢ɥ쥹ꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RSAR0), dst);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RSAR1), dst >> 8);

	/* DMA ߤ򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	                 ED_CR_RD1 | ED_CR_PAGE0 | ED_CR_STA);

	/* NIC ˽񤭹 */
	while (amount -- > 0)
		sil_wrb_mem((VP)(sc->asic_addr + ED_DATA_OFFSET), *src ++);
	}

/*
 * ed_get_frame -- Ethernet ե졼Ϥ롣
 */

static T_NET_BUF *
ed_get_frame (T_ED_SOFTC *sc, UW ring, UH len)
{
	T_NET_BUF	*input = NULL;
	UH		sublen, align;
	UB		*dst;
	ER		error;


	/*
	 *  +-----------+--------+---------+---------+
	 *  | Ehter HDR | IP HDR | TCP HDR | TCP SDU |
	 *  +-----------+--------+---------+---------+
	 *        14        20        20        n
	 *   <----------------- len ---------------->
	 *              ^
	 *              net_buf  4 ƥåȶ˥饤󤵤Ƥ롣
	 *
	 *  tcp_input  udp_input Ǥϡإå SDU ǥå
	 *  ׻뤬n  4 ƥåȶˤʤ褦 SDU θ 0 
	 *  ѥåǥ󥰤롣ʬθ net_buf ʤФʤʤ
	 */
	align = ((((len - sizeof(T_IF_HDR)) + 3) >> 2) << 2) + sizeof(T_IF_HDR);

	if ((error = tget_net_buf(&input, align, TMO_IF_ED_GET_NET_BUF)) == E_OK && input != NULL) {
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_PACKETS], 1);
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_OCTETS],  len);
		dst = input->buf;
		if (ring + len > ED_INT_RAM_BASE + ED_INT_RAM_SIZE) {
			sublen = (ED_INT_RAM_BASE + ED_INT_RAM_SIZE) - ring;
			ed_pio_readmem(sc, ring, dst, sublen);
			len -= sublen;
			dst += sublen;
			ring = ED_INT_RXBUF_START * ED_PAGE_SIZE;
			}
		ed_pio_readmem(sc, ring, dst, len);
		}
	else {
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_NO_BUFS], 1);
		}
	return input;
	}

/*
 *  ed_xmit -- ե졼롣
 *
 *    : NIC ߶ػ߾֤ǸƤӽФȡ
 */

static void
ed_xmit (T_IF_SOFTC *ic)
{
	T_ED_SOFTC *sc = ic->sc;

	/* 쥸ڡ 0 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);

	/* ڡꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_TPSR),
	            ED_INT_TXBUF_START + sc->txb_send * NUM_IF_ED_TXBUF_PAGE);

	/* 륪ƥåȿꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_TBCR0), sc->txb_len[sc->txb_send]);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_TBCR1), sc->txb_len[sc->txb_send] >> 8);

	/* 롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_TXP | ED_CR_STA);

	/* Хåեڤؤ롣*/
	sc->txb_send ++;
	if (sc->txb_send == NUM_IF_ED_TXBUF)
		sc->txb_send = 0;

	sc->txb_insend ++;

	/* ॢȤꤹ롣*/
	ic->timer = TMO_IF_ED_XMIT;
	}

/*
 *  ed_stop -- ed ͥåȥ󥿥եߤ롣
 *
 *    : NIC ߶ػ߾֤ǸƤӽФȡ
 */

static void
ed_stop (T_ED_SOFTC *sc)
{
	int wait;

	/* DMA ߤ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STP);

	/* NIC ߾֤ˤʤޤԤġ5[ms]¤ˤƤ롣*/
	for (wait = 5; ((sil_reb_mem((VP)(sc->nic_addr + ED_P0_ISR)) & ED_ISR_RST) == 0) && wait -- > 0; )
		syscall(dly_tsk(1));
	}

/*
 *  ed_init_sub -- ed ͥåȥ󥿥եν
 *
 *    : NIC ߶ػ߾֤ǸƤӽФȡ
 */

static void
ed_init_sub (T_IF_SOFTC *ic)
{
	T_ED_SOFTC	*sc = ic->sc;
	int		ix;

	/* ڡ */
	sc->rxb_read = ED_INT_RXBUF_START + 1;

	/* Хåե */
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], sc->txb_inuse);
	sc->txb_inuse  = 0;
	sc->txb_insend = 0;
	sc->txb_write  = 0;
	sc->txb_send   = 0;
	
	/* ॢȤꥻåȤ롣*/
	ic->timer = 0;

	/* 󥿥եߤ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR), ED_CR_PAGE0 | ED_CR_STP);

	/*
	 *  DCR ꤹ롣
	 *    FIFO Τͤ 8
	 *    롼ץХå⡼
	 */
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_DCR), ED_DCR_FT1 | ED_DCR_LS);

	/* RBCR 򥯥ꥢ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RBCR0), 0);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RBCR1), 0);

	/* ϥե졼¸ʤ*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RCR), ED_RCR_MON);

	/* 롼ץХå⡼ɤꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_TCR), ED_TCR_LB0);

	/* 󥰥Хåե */
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_TPSR),   ED_INT_TXBUF_START);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_PSTART), ED_INT_RXBUF_START);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_PSTOP),  ED_INT_RXBUF_STOP);
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_BNRY),   ED_INT_RXBUF_START);

	/* Ƥγߥե饰ꥻåȤ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_ISR), 0xff);

	/*
	 *  ߤĤ롣
	 *    λ
	 *    顼
	 *    С饤
	 */
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_IMR),
	            ED_IMR_PRX | ED_IMR_PTX | ED_IMR_RXE | ED_IMR_TXE | ED_IMR_OVW);

	/* 쥸ڡ 1 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE1 | ED_CR_STP);

	/* MAC ɥ쥹ꤹ롣*/
	for (ix = 0; ix < ETHER_ADDR_LEN; ix ++)
		sil_wrb_mem((VP)(sc->nic_addr + ED_P1_PAR(ix)), ic->ifaddr.lladdr[ix]);

	/* ե졼񤭹ڡꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P1_CURR), sc->rxb_read);

 	/* 쥸 (RCR) ꤹ롣*/
 	ed_setrcr(ic);

	/* 롼ץХå⡼ɤ̤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_TCR), 0);
	
	/* ǽޥե롣*/
	for (ix = NUM_IF_ED_TXBUF; ix --; )
		sig_sem(ic->semid_txb_ready);

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ʹ */

	/* åȰ¸γ߽ */
	ed_inter_init();

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */

	}

#ifndef SUPPORT_INET6

/*
 * ed_setrcr -- 쥸 (RCR) ꤹ롣
 */

static void
ed_setrcr (T_IF_SOFTC *ic)
{
	T_ED_SOFTC	*sc = ic->sc;
	int		ix;

	/* 쥸ڡ 1 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE1 | ED_CR_STP);

#ifdef IF_ED_CFG_ACCEPT_ALL

	/* ޥ㥹Ȥμ */
	for (ix = 0; ix < 8; ix ++)

		/* ޥ㥹ȤƼ롣*/
		sil_wrb_mem((VP)(sc->nic_addr + ED_P1_MAR(ix)), 0xff);

	/* 쥸ڡ 0 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	                 ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STP);

	/* ޥ㥹Ȥȥ顼ե졼褦ꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RCR),
	            ED_RCR_PRO | ED_RCR_AM | ED_RCR_AB |ED_RCR_SEP);

#else	/* of #ifdef IF_ED_CFG_ACCEPT_ALL */

	/* ޥ㥹Ȥμ */
	for (ix = 0; ix < 8; ix ++)

		/* ޥ㥹ȤƼʤ*/
		sil_wrb_mem((VP)(sc->nic_addr + ED_P1_MAR(ix)), 0x00);

	/* 쥸ڡ 0 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STP);

	/* ʬȥ֥ɥ㥹ȤΤ߼褦ꤹ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RCR), ED_RCR_AB);

#endif	/* of #ifdef IF_ED_CFG_ACCEPT_ALL */

	/* NIC ư롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);
	}

#endif	/* of #ifndef SUPPORT_INET6 */

/*
 * ed_reset -- ed ͥåȥ󥿥եꥻåȤ롣
 */

void
ed_reset (T_IF_SOFTC *ic)
{
	IPM	ipm;

	/* NIC γߤػߤ롣*/
	ipm = ed_dis_inter();

	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RESETS], 1);
	ed_stop(ic->sc);
	ed_init_sub(ic);

	/* NIC γߤĤ롣*/
	ed_ena_inter(ipm);
	}

/*
 *  get_ed_softc -- ͥåȥ󥿥եΥեȥ֤
 */

T_IF_SOFTC *
ed_get_softc (void)
{
	return &if_softc;
	}

/*
 * ed_watchdog -- ed ͥåȥ󥿥եΥåɥåॢ
 */

void
ed_watchdog (T_IF_SOFTC *ic)
{
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], 1);
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_TIMEOUTS], 1);
	ed_reset(ic);
	}

/*
 * ed_probe -- ed ͥåȥ󥿥եθ
 */

void
ed_probe (T_IF_SOFTC *ic)
{
#ifdef ED_CFG_HSB8S2638
	static const UB mac_order[] = { 3, 1, 7, 5, 11, 9 };
#else	/* #ifdef ED_CFG_HSB8S2638 */
	static const UB mac_order[] = { 1, 3, 5, 7, 9, 11 };
#endif	/* #ifdef ED_CFG_HSB8S2638 */

	UB		romdata[ETHER_ADDR_LEN * 2], tmp;
	T_ED_SOFTC	*sc = ic->sc;
	int		ix;

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ʹ */

	/* åȰ¸ΥХν */
	ed_bus_init();

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */

	/* ꥻåȤ롣*/
	tmp = sil_reb_mem((VP)(sc->asic_addr + ED_RESET_OFFSET));
	sil_wrb_mem((VP)(sc->asic_addr + ED_RESET_OFFSET), tmp);
	dly_tsk(5);

	/* DMA ߤ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STP);
	dly_tsk(5);

	/* ϥե졼¸ʤ*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_RCR), ED_RCR_MON);

	/*
	 *  DCR ꤹ롣
	 *    FIFO Τͤ 8
	 *    롼ץХå⡼
	 */
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_DCR), ED_DCR_FT1 | ED_DCR_LS);

	/* MAC ɥ쥹ɤ߹ࡣ*/
	ed_pio_readmem(sc, 0, romdata, ETHER_ADDR_LEN * 2);
	for (ix = 0; ix < ETHER_ADDR_LEN; ix ++)
		ic->ifaddr.lladdr[ix] = romdata[mac_order[ix]];

	/* Ƥγߥե饰ꥻåȤ롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_ISR), 0xff);
	}

/*
 * ed_init -- ed ͥåȥ󥿥եν
 */

void
ed_init (T_IF_SOFTC *ic)
{
	IPM	ipm;

	/* NIC γߤػߤ롣*/
	ipm = ed_dis_inter();

	/* ed_init ΤƤӽФ*/
	ed_init_sub(ic);

	/* NIC γߤĤ롣*/
	ed_ena_inter(ipm);
	}

/*
 * ed_read -- ե졼ɤ߹
 */

T_NET_BUF *
ed_read (T_IF_SOFTC *ic)
{
	T_ED_FRAME_HDR	frame_hdr;
	T_ED_SOFTC	*sc = ic->sc;
	T_NET_BUF	*input = NULL;
	IPM		ipm;
	UW		frame_ptr;
	int		len;
	UB		boundry;
	UB		curr;

	/* NIC γߤػߤ롣*/
	ipm = ed_dis_inter();

	/* 쥸ڡ 1 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE1 | ED_CR_STA);

	curr = sil_reb_mem((VP)(sc->nic_addr + ED_P1_CURR));
	if (sc->rxb_read != curr) {

		/* ե졼Ƭ롣*/
		frame_ptr = sc->rxb_read * ED_PAGE_SIZE;

		/* ե졼إå¤ΤФ*/
		ed_pio_readmem(sc, frame_ptr, (char *)&frame_hdr, sizeof(frame_hdr));

#if SIL_ENDIAN == SIL_ENDIAN_BIG

		frame_hdr.count = (frame_hdr.count << 8) | (frame_hdr.count >> 8);

#endif	/* of #if SIL_ENDIAN == SIL_ENDIAN_BIG */

		len = frame_hdr.count;
		if (len >  sizeof(T_ED_FRAME_HDR) &&
		    len <= IF_MTU + sizeof(T_ETHER_HDR) + sizeof(T_ED_FRAME_HDR) &&
		    frame_hdr.next >= ED_INT_RXBUF_START &&
		    frame_hdr.next <  ED_INT_RXBUF_STOP) {
			input = ed_get_frame(sc, frame_ptr + sizeof(T_ED_FRAME_HDR),
			                               len - sizeof(T_ED_FRAME_HDR));
			}
		else {
			/* 顼ȥꥻåȤϿ롣*/
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RESETS], 1);
			ed_stop(sc);
			ed_init_sub(ic);

			/* NIC γߤĤ롣*/
			ed_ena_inter(ipm);
			return NULL;
			}

		/* ե졼ݥ󥿤򹹿롣*/
		sc->rxb_read = frame_hdr.next;

		/* 쥸ڡ 0 򤹤롣*/
		sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
		            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);

		/* NIC ζݥ󥿤򹹿롣*/
		boundry = sc->rxb_read - 1;
		if (boundry < ED_INT_RXBUF_START)
			boundry = ED_INT_RXBUF_STOP - 1;
		sil_wrb_mem((VP)(sc->nic_addr + ED_P0_BNRY), boundry);

		/* 쥸ڡ 1 򤹤롣*/
		sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
		            ED_CR_RD2 | ED_CR_PAGE1 | ED_CR_STA);
		}

	/* 󥰥Хåե˥ǡĤäƤС³롣*/
	curr = sil_reb_mem((VP)(sc->nic_addr + ED_P1_CURR));
	if (sc->rxb_read != curr)
		sig_sem(ic->semid_rxb_ready);

	/* NIC γߤĤ롣*/
	ed_ena_inter(ipm);

	return input;
	}

/*
 * ed_start -- ե졼Хåե󥰤롣
 */

void
ed_start (T_IF_SOFTC *ic, T_NET_BUF *output)
{
	T_ED_SOFTC	*sc = ic->sc;
	IPM		ipm;

	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_PACKETS], 1);
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_OCTETS],  output->len);

	/* NIC γߤػߤ롣*/
	ipm = ed_dis_inter();

	/* Хåե˽񤭹ࡣ*/
	ed_pio_writemem(sc, output->buf, 
	                ED_INT_RAM_BASE + sc->txb_write * NUM_IF_ED_TXBUF_PAGE * ED_PAGE_SIZE,
	                output->len);

	/* Хåե˽񤭹ƥåȿϿ롣*/
	if (output->len > ETHER_MIN_LEN - ETHER_CRC_LEN)
		sc->txb_len[sc->txb_write] = output->len;
	else
		sc->txb_len[sc->txb_write] = ETHER_MIN_LEN - ETHER_CRC_LEN;

	/* Хåեڤؤ롣*/
	sc->txb_write ++;
	if (sc->txb_write == NUM_IF_ED_TXBUF)
		sc->txb_write = 0;

	sc->txb_inuse ++;

	/* ⤷ǤʤС򳫻Ϥ롣*/
	if (sc->txb_insend == 0)
		ed_xmit(ic);

	/* NIC γߤĤ롣*/
	ed_ena_inter(ipm);
	}

/*
 *  NIC ߥϥɥ
 */

void
if_ed_handler (void)
{
	T_ED_SOFTC	*sc;
	T_IF_SOFTC	*ic;
	UB		isr, tsr;
	UH		collisions;

	ic = &if_softc;
	sc = ic->sc;

	/* 쥸ڡ 0 򤹤롣*/
	sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
	            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);

	isr = sil_reb_mem((VP)(sc->nic_addr + ED_P0_ISR));

	if (isr != 0) {

		/* Ƥγߥե饰ꥻåȤ롣*/
		sil_wrb_mem((VP)(sc->nic_addr + ED_P0_ISR), isr);

		if (isr & (ED_ISR_PTX | ED_ISR_TXE)) {
			collisions = sil_reb_mem((VP)(sc->nic_addr + ED_P0_NCR)) & 0x0f;

			/*  */
			tsr = sil_reb_mem((VP)(sc->nic_addr + ED_P0_TSR));
			if (isr & ED_ISR_TXE) {

				/* 顼Ͽ롣*/
				if ((tsr & ED_TSR_ABT) && (collisions == 0)) {
					/*
					 * ꥸ 16 ΤȤP_NCR  0
					 * TSR_ABT  1 ˤʤ롣
					 */
					collisions = 16;
					}
				NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], 1);
				}

			if (sc->txb_insend)
				sc->txb_insend --;
			if (sc->txb_inuse)
				sc->txb_inuse  --;

			/* ॢȤꥻåȤ롣*/
			ic->timer = 0;

			/* ޤХåե˻ĤäƤ롣*/
			if (sc->txb_inuse)
				ed_xmit(ic);

			if (isig_sem(ic->semid_txb_ready) != E_OK)
				NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_TXB_QOVRS], 1);

			/* ꥸϿ롣*/
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_COLS], collisions);
			}

		if (isr & (ED_ISR_PRX | ED_ISR_RXE | ED_ISR_OVW)) {
			if (isr & ED_ISR_OVW) {

				/* 񤭥顼ȥꥻåȤϿ롣*/
				NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
				NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RESETS], 1);

				/* DMA ߤ롣*/
				sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
				            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STP);
				ed_init_sub(ic);
				}
			else {
				if (isr & ED_ISR_RXE) {

					/* 顼Ͽ롣*/
					NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
					}
				/* ߽ */
				if (isig_sem(ic->semid_rxb_ready) != E_OK)
					NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RXB_QOVRS], 1);
				}
			}

		/* 쥸ڡ 0 򤹤롣*/
		sil_wrb_mem((VP)(sc->nic_addr + ED_P0_CR),
		            ED_CR_RD2 | ED_CR_PAGE0 | ED_CR_STA);

		/* ͥåȥϿ󥿤ХեꥻåȤ롣*/
		if (isr & ED_ISR_CNT) {
			(void)sil_reb_mem((VP)(sc->nic_addr + ED_P0_CNTR0));
			(void)sil_reb_mem((VP)(sc->nic_addr + ED_P0_CNTR1));
			(void)sil_reb_mem((VP)(sc->nic_addr + ED_P0_CNTR2));
			}
		}
	}
