/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp.h,v 1.2.1.1 2004/10/13 06:00:43 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp.h	8.1 (Berkeley) 6/10/93
 * $FreeBSD: src/sys/netinet/tcp.h,v 1.10.2.1 1999/08/29 16:29:52 peter Exp $
 */
 
#ifndef _TCP_H_
#define _TCP_H_

/*
 *  TCP إåRFC 793 
 */

typedef struct t_tcp_hdr {
	UH	sport;		/* ݡֹ			*/
	UH	dport;		/* ݡֹ			*/

	UW	seq;		/* SEQ ֹ				*/

	UW	ack;		/* ACK ֹ				*/

	UB	off;		/* ǡեå(4ӥå)	*/
	UB	flags;		/* ե饰(6ӥå)			*/
	UH	win;		/* ɥ			*/

	UH	sum;		/* å				*/
	UH	urp;		/* ۵ޥݥ				*/
	} T_TCP_HDR;

#define TCP_HDR_SIZE			(sizeof(T_TCP_HDR))

/*
 *  TCP إå¤ΥХޥ
 */

#define TCP_MAKE_DATA_OFF(o)	(((o) << 2) & 0xf0)
#define TCP_DATA_OFF(o)		(((o) & 0xf0) >> 2)
#define TCP_HDR_LEN(o)		(TCP_DATA_OFF(o))

/*
 *  TCP إåΥե饰եɤͤ
 */

#define TCP_FLG_FIN		0x01	/* FIN:	ǽ			*/
#define TCP_FLG_SYN		0x02	/* SYN:	Ʊ			*/
#define TCP_FLG_RST		0x04	/* RST:	ͥΥꥻå	*/
#define TCP_FLG_PUSH		0x08	/* PUSH:ץå嵡ǽ		*/
#define TCP_FLG_ACK		0x10	/* ACK:			*/
#define TCP_FLG_URG		0x20	/* URG:	۵޾		*/

/*
 *  TCP ץ
 */

/* ץη */

#define TCP_OPT_EOL		0	/* ǽ				*/
#define TCP_OPT_NOP		1	/* ⤷ʤ			*/
#define TCP_OPT_MAXSEG		2	/* 祻Ĺ		*/
#define TCP_OPT_WINDOW		3	/* ɥ		*/
#define TCP_OPT_SACK_PERM	4	/*  ACK 		*/
#define TCP_OPT_SACK		5	/*  ACK			*/
#define TCP_OPT_TIMESTAMP	8	/* ॹ		*/
#define TCP_OPT_CC		11	/* ³			*/
#define TCP_OPT_CCNEW		12	/* ³			*/
#define TCP_OPT_CCECHO		13	/* ³			*/

/* ץĹ */

#define TCP_OPT_LEN_MAXSEG	4	/* 祻Ĺ		*/
#define TCP_OPT_LEN_WINDOW	3	/* ɥ		*/
#define TCP_OPT_LEN_SACK_PERM	4	/*  ACK 		*/
#define TCP_OPT_LEN_SACK	5	/*  ACK			*/
#define TCP_OPT_LEN_TIMESTAMP	10	/* ॹ		*/
#define TCP_OPT_LEN_CC		6	/* ³			*/
#define TCP_OPT_LEN_CCNEW	6	/* ³			*/
#define TCP_OPT_LEN_CCECHO	6	/* ³			*/

/*
 *  TCP 祻ȥ
 */

/*
 *  IPv4  TCP 祻ȥ
 *  IP4_MSS  576 ǡɸ IPv4 إåĹ (20) 
 *  TCP إåĹ (20)  536 Ǥ뤬512 ɸȤ롣
 */

#define TCP_MSS			512

/*
 *  IPv6  TCP 祻ȥ
 *  IP6_MSS  1280 ǡɸ IPv6 إåĹ (40) 
 *  TCP إåĹ (20)  1220 Ǥ뤬1024 ɸȤ롣
 */

#define TCP6_MSS		1024

/*
 *  TCP 祦ɥ
 */

#define MAX_TCP_WIN_SIZE	65535

#endif	/* of #ifndef _TCP_H_ */
