/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_output.c,v 1.2.1.1 2004/10/13 06:00:43 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_output.c	8.4 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_output.c,v 1.32.2.2 1999/08/29 16:29:55 peter Exp $
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>

#include <netinet6/in6_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>

/*
 *  ؿ
 */

static ER send_segment (BOOL *sendalot, T_TCP_CCEP *cep,
                        int off, int win, int len, UB flags, TMO tmout);

/*
 *  ѿ
 */

/* ϻΥե饰 FSM ֤ˤ򤹤뤿ɽ */

static UB tcp_outflags[] = {
	TCP_FLG_RST | TCP_FLG_ACK,	/*  0, 				*/
	0,				/*  1, ưץ			*/
	TCP_FLG_SYN,			/*  2, ǽưץSYN Ѥ	*/
	TCP_FLG_SYN | TCP_FLG_ACK,	/*  3, SYM SYN Ѥ	*/
	TCP_FLG_ACK,			/*  4, ͥߴλ		*/
	TCP_FLG_ACK,			/*  5, FIN Ԥ		*/
	TCP_FLG_FIN | TCP_FLG_ACK,	/*  6, λơFIN Ѥ		*/
	TCP_FLG_FIN | TCP_FLG_ACK,	/*  7, λFIN 򴹺ѤߡACK Ԥ	*/
	TCP_FLG_FIN | TCP_FLG_ACK,	/*  8, FIN λACK Ԥ		*/
	TCP_FLG_ACK,			/*  9, λFIN ãǧFINԤ	*/
	TCP_FLG_ACK,			/* 10, λԤ			*/
	};

/*
 *  send_segment -- TCP Ͻ
 */

static ER
send_segment (BOOL *sendalot, T_TCP_CCEP *cep, int off, int win, int len, UB flags, TMO tmout)
{
	T_NET_BUF	*output;
	T_TCP_HDR	*tcph;
	int		optlen;
	SYSTIM		before, after;
	ER		error;

#ifdef TCP_CFG_OPT_MSS

	UB		*optp;

	if (flags & TCP_FLG_SYN)
		optlen = TCP_OPT_LEN_MAXSEG;
	else
		optlen = 0;

#else/* of #ifdef TCP_CFG_OPT_MSS */

	optlen = 0;

#endif/* of #ifdef TCP_CFG_OPT_MSS */

	NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_SEGS], 1);
	NET_COUNT_MIB(tcp_stats.tcpOutSegs, 1);

	/*
	 *  ĹκĹĴ롣
	 *  ⤷ĶƤϡĶʬ롣
	 *  ΤᡢFIN ӥåȤ򥯥ꥢ롣
	 *
	 *  ꥸʥǤϡt_maxopd ĹˤƤ뤬
	 *  ܼǤϡκȤˤ롣
	 */
	if (len + optlen > cep->maxseg) {
		flags &= ~TCP_FLG_FIN;
		len = cep->maxseg - (len + optlen);
		*sendalot = TRUE;
		}

	/*
	 *  ХåեˤʤȤ PUSH ե饰ꤹ롣
	 */
	if (len && off + len >= cep->sbuf_count)
		flags |= TCP_FLG_PUSH;

	/* ȳƤλ֤ tmout 鸺롣*/
	syscall(get_tim(&before));

	if ((error = tcp_get_segment(&output, cep, optlen, len, tmout)) != E_OK) {
		return error;
		}

	/* ȳƤλ֤ tmout 鸺롣*/
	if (!(tmout == TMO_POL || tmout == TMO_FEVR)) {
		syscall(get_tim(&after));
		if (after - before > tmout)
			return E_TMOUT;
		tmout -= after - before;
		}


	/*
	 *  TCP ץԤ
	 *  ܼǤϡ祻ȥΤꤹ롣
	 */
	if (flags & TCP_FLG_SYN) {
		cep->snd_nxt = cep->iss;

#ifdef TCP_CFG_OPT_MSS

		optp = GET_TCP_OPT(output);
		*optp ++ = TCP_OPT_MAXSEG;
		*optp ++ = TCP_OPT_LEN_MAXSEG;
		*(UH*)optp = htons(DEF_TCP_RCV_SEG);

#endif/* of #ifdef TCP_CFG_OPT_MSS */

		}

	/*
	 *  TCP SDU ˥ǡ򥳥ԡ롣
	 */

#if NET_COUNT_ENABLE & PROTO_FLG_TCP

	if (len > 0) {
		if (SEQ_LT(cep->snd_nxt, cep->snd_max)) {
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_REXMIT_SEGS], 1);
			NET_COUNT_MIB(tcp_stats.tcpRetransSegs, 1);
			}
		tcp_seg_fill(cep, output, len, off);
		}
	else {
		if (cep->flags & CEP_FLG_ACK_NOW)
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_ACKS], 1);
		if (flags & (TCP_FLG_FIN | TCP_FLG_SYN | TCP_FLG_RST))
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_CNTL_SEGS],  1);

#if 0	/* ۵ޥǡϡĥǽΤα */
		if (SEQ_LT(cep->snd_up, cep->snd_una))
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_URG_SEGS], 1);
#endif	/* of #if 0 */

		}

#else	/* of #if NET_COUNT_ENABLE & PROTO_FLG_TCP */

	if (len > 0) {
		tcp_seg_fill(cep, output, len, off);
		}

#endif	/* of #if NET_COUNT_ENABLE & PROTO_FLG_TCP */

	/*
	 * snd_max:  SEQ
	 * snd_nxt:  SEQ
	 *
	 *  ꤫ FIN ޤ FIN Ƥʤ
	 *  ǡʤȤϡFIN Ϥ뤿ᡢ
	 *  Ȥ뤬SEQ Ͽʤʤ
	 */
	if ((flags & TCP_FLG_FIN) && (cep->flags & CEP_FLG_SENT_FIN) &&
	    cep->snd_nxt == cep->snd_max) {
		cep->snd_nxt --;
		}

	tcph = GET_TCP_HDR(output);

	/*
	 *  SEQACKե饰ꡣ
	 */
	if (len > 0 || (flags & (TCP_FLG_SYN | TCP_FLG_FIN)) || cep->timer[TCP_TIM_PERSIST] != 0)
		tcph->seq = htonl(cep->snd_nxt);
	else
		tcph->seq = htonl(cep->snd_max);

	/*
	 *  rcv_nxt: ԤƤǾ SEQ
	 */
	tcph->ack   = htonl(cep->rcv_nxt);
	tcph->flags = flags;

	/*
	 *  ɤη׻
	 *
	 *  rbufsz: ѥХåե
	 *  maxseg: κȥ	
	 */
	if (win < (long)(cep->rbufsz / 4) && win < (long)cep->maxseg)
		win = 0;

	/*
	 *  rcv_nxt: ԤƤǾ SEQ
	 *  rcv_adv: ԤƤ SEQ
	 */
	if (win < (long)(cep->rcv_adv - cep->rcv_nxt))
		win = (long)(cep->rcv_adv - cep->rcv_nxt);

	tcph->win = htons(win);

	/*
	 *  ۵ޥݥ󥿤
	 */
	if (SEQ_GT(cep->snd_up, cep->snd_nxt)) {
		tcph->urp    = htons((UH)(cep->snd_up - cep->snd_nxt));
		tcph->flags |= TCP_FLG_URG;
		}
	else
		cep->snd_up  = cep->snd_una;

	/*
	 *  åꤹ롣
	 */
	tcph->sum = IN_CKSUM(output, IPPROTO_TCP, GET_TCP_HDR_OFFSET(output),
		             GET_TCP_HDR_SIZE(output) + len);

	/* ͥåȥХåեĹĴ롣*/
	output->len = GET_IF_IP_TCP_HDR_SIZE(output) + len;

	/*
	 *  ޤĴ
	 */
	if ((cep->flags & CEP_FLG_FORCE) == 0 || cep->timer[TCP_TIM_PERSIST] == 0) {
		T_TCP_SEQ startseq = cep->snd_nxt;

		/*
		 *   SEQ (snd_nxt) 򺣲ǡʬʤ롣
		 */
		if (flags & TCP_FLG_SYN)
			cep->snd_nxt ++;
		if (flags & TCP_FLG_FIN) {
			cep->flags |= CEP_FLG_SENT_FIN;
			cep->snd_nxt ++;
			}

		cep->snd_nxt += len;

		/*
		 *   SEQ (snd_nxt) 
		 *   SEQ (snd_max) ʤǤС
		 *   SEQ (snd_max) 򹹿롣
		 */
		if (SEQ_GT(cep->snd_nxt, cep->snd_max)) {
			cep->snd_max = cep->snd_nxt;
			/*
			 *  ⤷ַ¬ԤäƤʤС
			 *  ˻֤碌롣
			 */
			if (cep->rtt == 0) {
				cep->rtt   = 1;
				cep->rtseq = startseq;	/*  cep->snd_nxt */
				}
			}

		/*
		 *  ⤷ꤵƤʤACK ޤαȯƤʤС
		 *  ޤꤹ롣ꤹͤϡ
		 * ֳ餫ʱ + 2  ưפǤ롣
		 *  ֤ΥХåդ˻Ȥ륷եȥȤ롣
		 */
		if (cep->timer[TCP_TIM_REXMT] == 0 && cep->snd_nxt != cep->snd_una) {
			cep->timer[TCP_TIM_REXMT] = cep->rxtcur;
			if (cep->timer[TCP_TIM_PERSIST] != 0) {
				cep->timer[TCP_TIM_PERSIST] = 0;
				cep->rxtshift = 0;
				}
			}
		}

	/*
	 *   SEQ (snd_nxt) + ǡ (len) 
	 *   SEQ (snd_max) ʤǤС
	 *   SEQ (snd_max) 򹹿롣
	 */
	else if (SEQ_GT(cep->snd_nxt + len, cep->snd_max))
		cep->snd_max = cep->snd_nxt + len;

	/* ͥåȥ (IP) νϴؿƤӽФ*/
	if ((error = IP_OUTPUT(output, tmout)) != E_OK) {
		/* %%% 顼 %%% */
		return error;
		}

	/*
	 *  ɥ (win)  0 ʾǡ
	 *  ԤƤǾ SEQ (rcv_nxt) + win 
	 *  ԤƤ SEQ (rcv_adv) ʤǤ
	 *  ԤƤ SEQ 򹹿롣
	 */
	if (win > 0 && SEQ_GT(cep->rcv_nxt + win, cep->rcv_adv))
		cep->rcv_adv = cep->rcv_nxt + win;

	/*
	 *  Ǹ ACK (last_ack_sent) 򹹿롣
	 */
	cep->last_ack_sent = cep->rcv_nxt;

	/*
	 *  ե饰Ԥ
	 */
	cep->flags &= ~(CEP_FLG_ACK_NOW | CEP_FLG_DEL_ACK);
	if (cep->flags & CEP_FLG_FORCE_CLEAR)
		cep->flags &= ~(CEP_FLG_FORCE | CEP_FLG_FORCE_CLEAR);

	return E_OK;
	}

/*
 *  tcp_output -- TCP Ͻ
 */

ER
tcp_output (T_TCP_CCEP *cep, TMO tmout)
{
	int		off, win, len;
	BOOL		sendalot = TRUE, idle;
	ER		error = E_OK;
	UB		flags;

	/*
	 *  snd_una: ̤ǧκǾ SEQ	 ޤϡǧ줿 SEQ
	 *  snd_max:  SEQ
	 */
	idle = (cep->snd_max == cep->snd_una);

	/*
	 *  idle:   ɥ
	 *  rxtcur: ߤκॢ
	 */
	if (idle && cep->idle >= cep->rxtcur)

		/*
		 *  snd_cwnd: ԥɥ
		 *  maxseg  : κȥ
		 *
		 *  Ĺ֥ɥäΤǥꤹ롣
		 */
		cep->snd_cwnd = cep->maxseg;

	while (error == E_OK && sendalot) {
		sendalot = FALSE;

		/*
		 *  snd_nxt:  SEQλǤϡ SEQ
		 *  snd_una: ̤ǧκǾ SEQޤϳǧ줿 SEQ
		 *
		 *  off: 򳫻Ϥ륪եåȡ
		 *                                    sbuf_count (Хåեˤ륪ƥåȿ)
		 *    0                               V
		 *    +-------------------------------------------+
		 *    |                    sbuf                   |
		 *    +-------------------------------------------+
		 *    ^               ^
		 *    |<------------->snd_nxt ( SEQ)
		 *    |       off
		 *    snd_una (ޤǧƤʤ)
		 */
		off   = cep->snd_nxt - cep->snd_una;

		/*
		 *  snd_wnd:  μǽɥ
		 *  snd_cwnd: ԥɥ
		 *
		 *  win: ɤ餫ɥꤹ롣
		 */
		win   = cep->snd_wnd < cep->snd_cwnd ? cep->snd_wnd : cep->snd_cwnd;
	
		/* ϥե饰 */
		flags = tcp_outflags[cep->fsm_state];
		if (cep->flags & CEP_FLG_NEED_FIN)
			flags |= TCP_FLG_FIN;
		if (cep->flags & CEP_FLG_NEED_SYN)
			flags |= TCP_FLG_SYN;
		if (cep->flags & CEP_FLG_FORCE) {

			/*
			 *  ⤷ɥ (win)  0 ʤ 1 ƥå롣
			 *  ǤʤС³ॢȤ򥭥󥻥뤷
			 *   (rxtshift)  0 ˤ롣
			 */
			if (win == 0) {

				/*
				 *  off:        륪ƥåȿ
				 *  sbuf_count: Хåեλ極
				 *
				 *  Хåե˻ĤäƤ륪ƥåȤ줫
				 *  褦ȤƤ륪ƥåȿ¿
				 *  FIN ե饰򥯥ꥢ롣
				 */
				if (off < cep->sbuf_count)
					flags &=~TCP_FLG_FIN;
				win = 1;
				}
			else {
				/*
				 *  TCP_TIM_PERSIST: ³
				 *  rxtshift:         log(2)
				 */
				cep->timer[TCP_TIM_PERSIST] = 0;
				cep->rxtshift = 0;
				}
		 	}

		/*
		 *  len: 륪ƥåȿ
		 *        sbuf_count (Хåեˤ륪ƥåȿ)
		 *                                    |
		 *    0                               V
		 *    +-------------------------------------------+
		 *    |                    sbuf       |           |
		 *    +-------------------------------------------+
		 *    ^               ^<------------->
		 *    |               |      len
		 *    |<------------->snd_nxt ( SEQ)
		 *    |       off
		 *    snd_una (ޤǧƤʤ)
		 */
		if (cep->sbuf_count < win)
			len = (long)cep->sbuf_count - off;
		else
			len = (long)win - off;

		/*
		 *  ǤƤСSYN ӥåȤ򥪥դ롣
		 *  ʲξǤ򹵤롣
		 *
		 *    ֤ SYN 
		 *    ȤǡޤǤ롣
		 */
		if ((flags & TCP_FLG_SYN) && SEQ_GT(cep->snd_nxt, cep->snd_una)) {
			flags &= ~TCP_FLG_SYN;
			off --;			/* -1  SYN ե饰ʬ */
			len ++;			/* +1  SYN ե饰ʬ */
			if (len > 0 && cep->fsm_state == TCP_FSM_SYN_SENT)
				return FALSE;
			}

		if (flags & TCP_FLG_SYN) {
			len = 0;
			flags &= ~TCP_FLG_FIN;
			}

		if (len < 0) {

			/*
			 *  len  0 ʲʤ顢0 ꤹ롣
			 *  ⤷ɥ 0 ʤ顢
			 *  ޤ򥭥󥻥뤷
			 *   SEQ (snd_nxt) 
			 *  ǧ줿 SEQ (snd_una) ᤹
			 *  ơ³ޡߤޤäƤСꤹ롣
			 */
			len = 0;
			if (win == 0) {
				cep->timer[TCP_TIM_REXMT] = 0;
				cep->rxtshift = 0;
				cep->snd_nxt  = cep->snd_una;
				if (cep->timer[TCP_TIM_PERSIST] == 0)
					tcp_set_persist_timer(cep);
				}
			}


		/*
		 *  륪ƥåȿ (len) ϡ
		 *  κȥ (maxseg) Ķʤ褦ˤ롣
		 */
		if (len > cep->maxseg) {
			len = cep->maxseg;
			sendalot = TRUE;
			}

		/*
                 *        sbuf_count (Хåեˤ륪ƥåȿ)
                 *                                           |
		 *    0                                      V
		 *    +-------------------------------------------+
		 *    |                    sbuf       |           |
		 *    +-------------------------------------------+
		 *    ^               ^<------------->
		 *    |               |      len
		 *    |<------------->snd_nxt ( SEQ)
		 *    |       off
		 *    snd_una (ޤǧƤʤ)
		 *
		 *  ⡢Хåե˥ǡĤäƤ
		 *  FIN ե饰򥯥ꥢ롣
		 */
		if (SEQ_LT(cep->snd_nxt + len, cep->snd_una + cep->sbuf_count))
			flags &= ~TCP_FLG_FIN;

		/*
		 *   win ϡɥ
		 *  Хåեζ
		 */
		win = cep->rbufsz - cep->rbuf_count;

		/*
		 *  򤫤ʥɥɥβ (¦)
		 *
		 *  ʲξǡԤ
		 *
		 *    ե륵 (maxseg) ΥȤ뤳ȤǤ롣
		 *    κμɥ 1/2 Υǡ
		 *      뤳ȤǤ롣
		 *    ХåեˤǤɥ뤫ٱ䥪ץͭʤȤ
		 */
		if (len) {

			/*
			 *  륪ƥåȿ (len) 
			 *  κȥ (maxseg) 
			 *  פȤ롣
			 */
			if (len == cep->maxseg) {
				error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
				continue;
				}

			/*
			 *  ǡХåեˤǤ
			 *  ɥ뤫 PUSH ץͭʤȤ
			 */
			if ((idle || (cep->flags & CEP_FLG_NO_DELAY)) &&
			    (cep->flags & CEP_FLG_NO_PUSH) == 0 &&
			    len + off >= cep->sbuf_count) {
				error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
				continue;
				}

			/*
			 *  max_sndwnd: ޤǤκɥ
			 *  snd_nxt:     SEQ
			 *  snd_max:     SEQ
			 *
			 *  ξǤԤ
			 *
			 *    ե饰åȤƤ롣
			 *    ǡĹκμɥ 1/2 ʾǡ
			 *      κμɥ 0 礭
			 *     SEQ  SEQ 꾮
			 *      ĤޤꡢȤ
			 */
			if ((cep->flags & CEP_FLG_FORCE) ||
			    (len >= cep->max_sndwnd / 2 && cep->max_sndwnd > 0) ||
			    SEQ_LT(cep->snd_nxt, cep->snd_max)) {
				error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
				continue;
				}
			}


		/*
		 *  򤫤ʥɥɥβ (¦)
		 *
		 *  ɥե륵 2 ܤΥȡ뤤
		 *  Хåե̤ 1/2 Ρ줫ۤ
		 *  äϡɥιԤ
		 */
		if (win > 0) {
			long adv;

			/*
			 *  win:              Хåեζ
			 *  MAX_TCP_WIN_SIZE: TCP إå win եɤǤ
			 *  rcv_adv:          ԤƤ SEQ
			 *  rcv_nxt:          ԤƤǾ SEQ
			 */
			if (win < (long)MAX_TCP_WIN_SIZE)
				adv = win - (cep->rcv_adv - cep->rcv_nxt);
			else
				adv = MAX_TCP_WIN_SIZE - (cep->rcv_adv - cep->rcv_nxt);

			if (adv     >= (long)(cep->maxseg * 2) ||
			    adv * 2 >= (long) cep->rbufsz) {
				error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
				continue;
				}
			}
	
		/*
		 *  ACK 롣
		 */
		if (cep->flags & CEP_FLG_ACK_NOW) {
			error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
			continue;
			}

		if ( (flags & TCP_FLG_RST) ||
		    ((flags & TCP_FLG_SYN) && (cep->flags & CEP_FLG_NEED_SYN) == 0)) {
			error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
			continue;
			}

		if (SEQ_GT(cep->snd_up, cep->snd_una)) {
			error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
			continue;
			}

		/*
		 *  snd_nxt:  SEQ
		 *  snd_una: ̤ǧκǾ SEQޤϳǧ줿 SEQ
		 *
		 *  ꤫ FIN ޤ FIN Ƥʤ
		 *  ǡʤȤϡFIN Ϥ뤿ᡢ
		 *  Ȥ롣
		 */
		if ((flags & TCP_FLG_FIN) &&
		    ((cep->flags & CEP_FLG_SENT_FIN) == 0 || cep->snd_nxt == cep->snd_una)) {
			error = send_segment(&sendalot, cep, off, win, len, flags, tmout);
			continue;
			}

		/*
		 *  ٤ǡꡢޤȻ³ޤڤƤȤ
		 *  ³ޤꤹ롣
		 */
		if (cep->sbuf_count && cep->timer[TCP_TIM_REXMT  ] == 0 &&
		                       cep->timer[TCP_TIM_PERSIST] == 0) {
			cep->rxtshift = 0;
			tcp_set_persist_timer(cep);
			break;
			}
		
		}
	return error;
	}

/*
 *  TCP ϥ
 */

void
tcp_output_task (VP_INT exinf)
{
	T_TCP_CCEP	*cep;
	ID		tskid;
	int		ix;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP OUTPUT:%d] started.", tskid);

	tcp_init();

#ifdef SUPPORT_INET6

	/* IPv6 Υơȥ쥹ɥ쥹ư¹Ԥ롣*/
	in6_if_up(IF_GET_IFNET());

#endif	/* of #ifdef SUPPORT_INET6 */

	while (TRUE) {

		/* ϤݥȤޤԤġ*/
		syscall(wai_sem(SEM_TCP_POST_OUTPUT));

		for (ix = tmax_tcp_ccepid; ix -- > 0; ) {

			cep = &tcp_ccep[ix];
			if (cep->flags & CEP_FLG_POST_OUTPUT) {

				if (cep->snd_nblk_tfn == TFN_TCP_CON_CEP && cep->myaddr.portno == TCP_PORTANY) {
				 	ER	error;

					/*
					 *  tcp_con_cep ΥΥ֥å󥰥ǡ
					 *  ̤ΤξϡݡֹƤ롣
					 *  p_myaddr  NADR (-1) 
					 *  ݡֹ椬 TCP_PORTANY ʤ顢ưǳƤ롣
					 */
					if ((int)cep->p_myaddr == NADR || cep->p_myaddr->portno == TCP_PORTANY)
						tcp_alloc_auto_port(cep);
					else if ((error = tcp_alloc_port(cep, cep->p_myaddr->portno)) != E_OK) {
						if (cep->callback == NULL)
							syslog(LOG_WARNING, "[tcp_output] no call back.");
						else
							(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)error);

						/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
						cep->snd_tskid = TA_NULL;
						cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;

						cep->flags &= ~CEP_FLG_POST_OUTPUT;
						continue;
						}
					}


				cep->flags &= ~CEP_FLG_POST_OUTPUT;
				tcp_output(cep, TMO_TCP_OUTPUT);
				}
			}
		}
	}
