/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: nd6.c,v 1.2.1.1 2004/10/13 06:00:55 abe Exp abe $
 */

/*	$FreeBSD: src/sys/netinet6/nd6.c,v 1.20 2002/08/02 20:49:14 rwatson Exp $	*/
/*	$KAME: nd6.c,v 1.144 2001/05/24 07:44:00 itojun Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * XXX
 * KAME 970409 note:
 * BSD/OS version heavily modifies this code, related to llinfo.
 * Since we don't have BSD/OS version of net/route.c in our hand,
 * I left the code mostly as it was in 970310.  -- itojun
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet6/nd6.h>

#include <netinet/icmp6.h>

#include <net/if6_var.h>

/*
 *  ٥å
 */

static T_LLINFO_ND6 nd6_cache[NUM_ND6_CACHE_ENTRY];

/*
 *  nd6_timer -- õޡ
 */

void
nd6_timer (void)
{
	T_LLINFO_ND6	*ln;
	T_IFNET		*ifp = IF_GET_IFNET();
	SYSTIM		now;
	int		ix;

	/* ٥åν */
	syscall(get_tim(&now));
	syscall(wai_sem(SEM_ND6_CACHE));
	for (ix = NUM_ND6_CACHE_ENTRY; ix -- > 0; ) {
		ln = &nd6_cache[ix];
		if (ln->state >= ND6_LLINFO_NO_STATE &&
		    (int)(ln->expire - now) <= 0) {	/* ln->expire <= now */

			switch (ln->state) {

			case ND6_LLINFO_INCOMPLETE:	/* ̤		*/
				if (ln->asked < ND6_MAX_MCAST_QUERY) {
					/*
					 *  ޥ㥹ȥɥ쥹κʲξν
					 */
					ln->asked ++;
					ln->expire = now + ND6_RETRANS_TIME;	/* õֳ */
					nd6_ns_output(ifp, &in6_addr_unspecified, &ln->addr, ln, FALSE);
					}
				else  {
					if (ln->hold != NULL) {
						/*
						 *  ǽŪˤϡαƤͥåȥХåե
						 *  СICMP6 ERROR ʬȤ֤ȡ
						 *  ͥåȥХåե롣
						 *  ߡicmp6_error μԴΤᡢ
						 *  ͥåȥХåեγΤ߹Ԥ
						 */
#if 0
						icmp6_error(ln->hold, ICMP6_DST_UNREACH,
						                      ICMP6_DST_UNREACH_ADDR, 0);
#endif	/* #if 0 */
						syscall(rel_net_buf(ln->hold));
						ln->hold = NULL;
						}
					memset((VP)ln, 0, sizeof(*ln));
					}
				break;

			case ND6_LLINFO_REACHABLE:	/* ãǽ		*/
				if (ln->expire) {
					ln->expire = now + ND6_GCOLLECTION_TIME;
					ln->state = ND6_LLINFO_STALE;
					}
				break;

			case ND6_LLINFO_STALE:		/* ãǽ̤ǧ	*/
				if (ln->expire) {
					if (ln->hold != NULL) {
						syscall(rel_net_buf(ln->hold));
						ln->hold = NULL;
						}
					memset((VP)ln, 0, sizeof(*ln));
					}
				break;

			case ND6_LLINFO_DELAY:		/* ãǽγǧԵ	*/
				ln->asked = 1;
				ln->expire = now + ND6_RETRANS_TIME;		/* õֳ */
				ln->state = ND6_LLINFO_PROBE;
				nd6_ns_output(ifp, &ln->addr, &ln->addr, ln, FALSE);
				break;

			case ND6_LLINFO_PROBE:		/* ãǽǧ	*/
				if (ln->asked < ND6_MAX_UCAST_QUERY) {
					/*
					 *  ˥㥹ȥɥ쥹κʲξν
					 */
					ln->asked ++;
					ln->expire = now + ND6_RETRANS_TIME;	/* õֳ */
					nd6_ns_output(ifp, &ln->addr, &ln->addr, ln, FALSE);
					}
				else {
					if (ln->hold != NULL) {
						syscall(rel_net_buf(ln->hold));
						ln->hold = NULL;
						}
					memset((VP)ln, 0, sizeof(*ln));
					}
				break;

				}
			}
		}
	syscall(sig_sem(SEM_ND6_CACHE));

	/* ǥեȥ롼ꥹȤν */
	nd6_defrtrlist_timer();

	/* ͥåȥ󥿥եΥɥ쥹ν */
	in6_ifaddr_timer(ifp);

	/*
	 *  ãǽ֤֤ͭι
	 */
	if ((int)(nd6_recalc_reachtm_interval - now) <= 0) {
		nd6_recalc_reachtm_interval	= now + ND6_RECALC_REACHTM_INTERVAL;
		nd6_reachable_time		= ND6_CALC_REACH_TIME(nd6_base_reachable_time);
		}
	}

/*
 *  nd6_get_cache -- ٥å롣
 */

const T_LLINFO_ND6 *
nd6_get_cache (void)
{
	return nd6_cache;
	}

/*
 *  nd6_ifattach -- õνԤ
 */

void
nd6_ifattach (T_IFNET *ifp)
{
	}

/*
 *  nd6_output_hold -- õåαƤ
 *                     ɥ쥹ԤΥǡब롣
 *
 *    : ޥե SEM_ND6_CACHE ˤå֤ǸƽФȡ
 */

ER
nd6_output_hold (T_IFNET *ifp, T_LLINFO_ND6 *ln)
{
	SYSTIM now;

	/* ɥ쥹ԤΥǡब롣*/
	if (ln->hold) {

		/* ॢȤν */
		if (ln->tmout != TMO_FEVR) {

			/*
			 *  ॢȤλ꤬ʵפǤʤ֤᤮ƤС
			 *  Ϥʤǽλ롣
			 */
			syscall(get_tim(&now));
			if ((int)(ln->tmout - now) < 0) {	/* ln->tmout < now */
				syscall(rel_net_buf(ln->hold));
				ln->hold = NULL;
				return E_TMOUT;
				}
			}
				
		nd6_output(ifp, ln->hold, &ln->addr, ln, TMO_FEVR);
		ln->hold = NULL;
		}
	return E_OK;
	}

/*
 *  nd6_lookup -- õåõ롣
 *
 *    : ޥե SEM_ND6_CACHE ˤå֤ǸƽФȡ
 *
 */

T_LLINFO_ND6 *
nd6_lookup (T_IN6_ADDR *addr, BOOL create)
{
	int	ix, fix = -1, mix = -1;
	UW	min = 0xffffffff;

	for (ix = NUM_ND6_CACHE_ENTRY; ix -- > 0; ) {
		if (nd6_cache[ix].state == 0) {
			/* ̤ѥȥΥǥåϿ롣*/
			if (fix == -1)
				fix = ix;
			}
		else if (IN6_ARE_ADDR_EQUAL(addr, &nd6_cache[ix].addr))
			return &nd6_cache[ix];
		else if ((int)(nd6_cache[ix].expire - min) < 0) {	/* nd6_cache[ix].expire < min */
			/* ͭ¤ûȥΥǥåϿ롣*/
			min = nd6_cache[ix].expire;
			mix = ix;
			}
		}

	if (create) {
		if (fix == -1)  {
			if (nd6_cache[mix].hold != NULL)
				syscall(rel_net_buf(nd6_cache[mix].hold));
			fix = mix;
			}
		syscall(get_tim(&nd6_cache[fix].expire));
		nd6_cache[fix].addr   = *addr;
		nd6_cache[fix].state  = ND6_LLINFO_NO_STATE;
		return &nd6_cache[fix];
		}
	else
		return NULL;
	}

/*
 *  nd6_cache_lladdr -- õåϿ롣
 */

T_LLINFO_ND6 *
nd6_cache_lladdr (T_IFNET *ifp, T_IN6_ADDR *from, T_IF_ADDR *lladdr, int type, int code)
{
	T_LLINFO_ND6	*ln;
	SYSTIM		now;
	BOOL		newentry;
	BOOL		olladdr;
	BOOL		llchange;
	BOOL		doupdate;
	int		newstate = ND6_LLINFO_INCOMPLETE;

	/* ɥ쥹̵ʤ鲿⤷ʤ*/
	if (IN6_IS_ADDR_UNSPECIFIED(from))
		return NULL;

	/* ٥åϿ롣*/
	syscall(wai_sem(SEM_ND6_CACHE));
	if ((ln = nd6_lookup(from, FALSE)) == NULL) {
		ln = nd6_lookup(from, TRUE);
		newentry = TRUE;
		}
	else
		newentry = FALSE;

	olladdr = ln->state > ND6_LLINFO_INCOMPLETE;
	if (!olladdr || lladdr == NULL)
		llchange = FALSE;
	else if (memcmp(lladdr, &ln->ifaddr, sizeof(T_IF_ADDR)))
		llchange = TRUE;
	else
		llchange = FALSE;

	/*
	 *  ɽ
	 *
	 *  nd_na_flags
	 *  newnetry olladdr lladdr llchange  (L: lladdr Ͽ)
	 *
	 *      F       F       N       -    (1)
	 *      F       T       N       -    (2)
	 *      F       F       Y       -    (3) L * -> STALE
	 *      F       T       Y       F    (4) L
	 *      F       T       Y       T    (5) L * -> STALE
	 *      T       -       N       -    (6)   * -> NO_STATE
	 *      T       -       Y       -    (7) L * -> STALE
	 */

	/* ǡؤΥɥ쥹ΤƤй롣*/
	if (lladdr != NULL)
		ln->ifaddr = *(T_IF_ADDR *)lladdr;
	

	if (newentry) {
		if (lladdr != NULL)					/* (7) */
			newstate = ND6_LLINFO_STALE;
		else							/* (6) */
			newstate = ND6_LLINFO_NO_STATE;
		doupdate = TRUE;
		}
	else {
		if ((!olladdr && lladdr != NULL) ||			/* (3) */
		    ( olladdr && lladdr != NULL && llchange)) {		/* (5) */
			newstate = ND6_LLINFO_NO_STATE;
			doupdate = TRUE;
			}
		else							/* (1),(2),(4) */
			doupdate = FALSE;
		}

	/* ٥å奨ȥ򹹿롣*/
	if (doupdate) {
		ln->state = newstate;

		syscall(get_tim(&now));
		if (ln->state == ND6_LLINFO_STALE) {
			ln->expire = now + ND6_GCOLLECTION_TIME;

			/* ɥ쥹ԤΥǡब롣*/
			nd6_output_hold(ifp, ln);
			}
		else if (ln->state == ND6_LLINFO_INCOMPLETE)
			ln->expire = now;
		}
	syscall(sig_sem(SEM_ND6_CACHE));

	/* 롼Τν: ̤ */

	return ln;
	}

/*
 *  nd6_is_addr_neighbor -- ꤵ줿ɥ쥹ΥΡɤƱ󥯤ˤ뤫å롣
 */

BOOL
nd6_is_addr_neighbor (T_IFNET *ifp, T_IN6_ADDR *addr)
{
	int ix;

	if (IN6_IS_ADDR_LINKLOCAL(addr))
		return TRUE;

	for (ix = 0; ix < MAX_IN6_IFADDR_CNT; ix ++) {
		if (ifp->in_ifaddrs[ix].flags & IN6_IFF_DEFINED &&
		    in6_are_prefix_equal(&ifp->in_ifaddrs[ix].addr, addr, ifp->in_ifaddrs[ix].prefix_len)) {
			return TRUE;
			}
		}

	if (nd6_lookup(addr, FALSE) != NULL)
		return TRUE;

	return FALSE;
	}

/*
 *  nd6_output -- õνϴؿ
 *
 *    : ޥե SEM_ND6_CACHE ˤå֤ǸƽФȡ
 */

ER
nd6_output (T_IFNET *ifp, T_NET_BUF *output, T_IN6_ADDR *dst, T_LLINFO_ND6 *ln, TMO tmout)
{
	ER	error = E_OK;
	SYSTIM	now;

	/*
	 *  襢ɥ쥹ޥ㥹Ȥ٥å夬
	 *  פξľ롣
	 */
	if (!(IN6_IS_ADDR_MULTICAST(dst) || !IF_IN6_NEED_CACHE(ifp))) {
		if (ln == NULL) {
			/* ٥å夬̤ξ */
			if (nd6_is_addr_neighbor(ifp, dst)) {
				/*
				 *  ꤵ줿ɥ쥹ΥΡɤƱ󥯤ˤϡ
				 *  ٥åõ̤ξϿ롣
				 */
				ln = nd6_lookup(dst, TRUE);
				}
			else {
				error = E_CLS;
				goto err_ret;
				}
			}

		/*
		 *  ٥åξ֤ǡؤΥɥ쥹ʬäƤƤ⡢
		 *  ãǽǧƤʤȤϡãǽΤ򳫻Ϥ롣
		 */
		if (ln->state == ND6_LLINFO_STALE) {
			syscall(get_tim(&now));
			ln->expire = now + ND6_DELAY_TIME;
			ln->asked = 0;
			ln->state = ND6_LLINFO_DELAY;
			}

		/*
		 *  ٥åξ֤ǡؤΥɥ쥹̤ξ
		 *  õԤ
		 */
		if (ln->state <= ND6_LLINFO_INCOMPLETE) {

			/* ॢȤλ꤬ݡ󥰤ʤ饿ॢȤǽλ롣*/
			if (tmout == TMO_POL) {
				error = E_TMOUT;
				goto err_ret;
				}

			if (ln->state == ND6_LLINFO_NO_STATE)
				ln->state = ND6_LLINFO_INCOMPLETE;

			/* Ǥˡ̤ΥͥåȥХåեС롣*/
			if (ln->hold != NULL) {
				syscall(rel_net_buf(ln->hold));
				}

			ln->hold  = output;

			/* ॢȤ */
			if (tmout == TMO_FEVR)
				ln->tmout = tmout;
			else {
				syscall(get_tim(&now));
				ln->tmout = now + tmout;
				}

			if (ln->expire) {
				if (ln->asked < ND6_MAX_MCAST_QUERY) {
					syscall(get_tim(&now));
					if ((int)(ln->expire - now) < 0) {	/* ln->expire < now */
						ln->expire = now + ND6_RETRANS_TIME;	/* õֳ */
						ln->asked ++;
						nd6_ns_output(ifp, &in6_addr_unspecified, dst, ln, FALSE);
						}
					}
				}
			return error;
			}
		}

	IF_SET_PROTO(output, IF_PROTO_IPV6);
	error = IF_OUTPUT(output, dst, ln ? & ln->ifaddr : NULL, tmout);
	return error;

err_ret:
	syscall(rel_net_buf(output));
	return error;
	}

/*
 *  nd6_storelladdr -- Ϥͥåȥ󥿥եΥɥ쥹֤
 */

ER
nd6_storelladdr (T_IF_ADDR *out, T_IN6_ADDR *dst, T_IF_ADDR *ifa)
{
	if (IN6_IS_ADDR_MULTICAST(dst)) {
		IF_IN6_RESOLVE_MULTICAST(out, dst);
		}
	else {
		*out = *ifa;
		}

	return E_OK;
	}

/*
 *  nd6_option -- õץν
 *
 *    : ץ󥪥եåˤϡեå + 8 ꤵƤ롣
 */

ER
nd6_options (UB *opt, VP nh, int len)
{
	T_ND_OPT_HDR	*opth;
	ER		error = E_OK;
	int		pi_count = 0;	/* ץեåθĿ */

	opth = (T_ND_OPT_HDR *)nh;
	memset(opt, 0, ND_OPT_OFF_ARRAY_SIZE);

	while (error == E_OK && ((UB *)opth - (UB *)nh) < (256 - 8) && len > 0) {

		/* ץΥפˤʬ롣*/
		switch (opth->type) {
		case ND_OPT_SOURCE_LINKADDR:		/* ͥåȥ󥿥եΥɥ쥹	*/
		case ND_OPT_TARGET_LINKADDR:		/* оݥͥåȥ󥿥եΥɥ쥹	*/
		case ND_OPT_REDIRECTED_HEADER:		/* 쥯ȡإå				*/
		case ND_OPT_MTU:			/* MTU						*/
			if (opt[ND_OPT_OFF_ARRAY_IX(opth->type)]) {
				/* ץեåʳƱץʣꤵƤ롣*/
				error = E_PAR;
				}
			else {
				opt[ND_OPT_OFF_ARRAY_IX(opth->type)] = (UB *)opth - (UB *)nh + 8;
				len -= opth->len << 3;		/* ץĹñ̤ 8 Х */
				opth = (T_ND_OPT_HDR *)((UB *)opth + (opth->len << 3));
				}
			break;
		case ND_OPT_PREFIX_INFORMATION:		/* ץեå				*/
			if (!opt[ND_OPT_OFF_ARRAY_IX(ND_OPT_PREFIX_INFORMATION)]) {
				/*
				 *  ץեåϺǽ˸줿եåȤΤߵϿ롣
				 */
				opt[ND_OPT_OFF_ARRAY_IX(opth->type)] = (UB *)opth - (UB *)nh + 8;
				}
			pi_count ++;
			len -= opth->len << 3;		/* ץĹñ̤ 8 Х */
			opth = (T_ND_OPT_HDR *)((UB *)opth + (opth->len << 3));
			break;
		default:
			error = E_PAR;
			break;
			}
		}

	opt[ND_OPT_OFF_ARRAY_IX(ND_OPT_PREFIX_INFO_COUNT)] = pi_count;
	return error;
	}
